#
# 񤭤ǥ쥯ȥ
#
# Copyright (c) Fuktommy <fuktommy@my.tramonline.net>
#
# Released under the GNU General Public License
#

package Hicky::LogList;
use Hicky::Lookup;
use Hicky::Directory;
use Hicky::System;
use Hicky::LoggedThread;
push @ISA, 'Hicky::Directory';

#-------------------------------------------------------------------------#
# 󥹥ȥ饯
# : ǥ쥯ȥ̾
sub new {
	my($this, $hostname) = @_;
	my $lookup = new Hicky::Lookup();
	my $index = "$hostname/$main::conf{name_index}";
	my $bookmark = "$hostname/$main::conf{name_bookmark}";
	my %thread;

	if (-e $index) {
		%thread = $this->readIndex($index, $hostname);
	} else {
		return $this->SUPER::new($hostname);
	}

	if (-e $bookmark) {
		$lookup->addBookmark($bookmark, \%thread);
	}

	$this = {thread=>\%thread, lookup=>$lookup, dir=>$hostname, done=>[]};
	return bless $this;
}

#-------------------------------------------------------------------------#
# ǥ쥯ȥˤɤ߹
# : ǥåե̾, ǥ쥯ȥ̾
# : ѥåɤΥϥå塣ȥǸǤ롣
sub readIndex {
	my($this, $index, $dir) = @_;
	my %thread = ();
	local $_;
	my @input = Hicky::System::cat($index);

	foreach (@input) {
		if (/^<a href='([^']+)'>\d+: ([^<]+)<\/a><br>$/) {
			my $file = $1;
			my $title = $2;
			$thread = new Hicky::LoggedThread("$dir/$file", $title);
			$thread{$title} = $thread;
		}
	}
	return %thread;
}

1;
