#
# å
#
# Copyright (c) Fuktommy <fuktommy@my.tramonline.net>
#
# Released under the GNU General Public License
#

package Hicky::Thread;

#-------------------------------------------------------------------------#
# 󥹥ȥ饯
# : ե
sub new {
	my($this, @input) = @_;
	my($title, @article);
	my $max = 0;
	local $_  = join "", @input;
	if (m|<title>\n?([^\n<>]*)\n?</title>|i) {
		$title = $1;
		$title =~ s/^ +//;
		$title =~ s/ +$//;
	} else {
		# print "NG: $input\n";
		return undef;
	}

	foreach (split /<dt>|<\/dl>|<table|<form|<p/i) {
		s/^<a[^>]*>//i;
		s/\n//;
		if (/^\d+/) {
			$article[$&] = $_;
			$max = $& if ($max < $&);
		}
	}

	return undef if (@article == 0);
	$this = {title=>$title, max=>$max, article=>\@article, load=>1};
	return bless $this;
}

#-------------------------------------------------------------------------#
# ȥμ
# : ȥ
sub getTitle {
	my($this) = @_;
	return $$this{title};
}

#-------------------------------------------------------------------------#
# ȥμ(ڡʤ)
# : ȥ
sub getTitleNoSpace {
	my($this) = @_;
	my $title = $$this{title};
	$title =~ s/ +//g;
	return $title;
}

#-------------------------------------------------------------------------#
# Υ쥹ֹμ
# : Υ쥹ֹ
sub getMaxRes {
	my($this) = @_;
	return $$this{max};
}

#-------------------------------------------------------------------------#
# 쥹μ
# : 쥹ֹ
# : 쥹ʸ
sub getArticle {
	my($this, $i) = @_;
	return $$this{article}[$i];
}

#-------------------------------------------------------------------------#
# 쥹
# Ǥ˥쥹о񤭤ʤ
# : 쥹ֹ, 쥹ʸ
# : ꤷɤ
sub setArticle {
	my($this, $i, $str) = @_;
	if ((defined $$this{article}[$i])
			&&($$this{article}[$i] !~ /ܡ<dd>/)) {
		return 0;
	} else {
		$$this{article}[$i] = $str;
		$$this{max} = $i if ($$this{max} < $i);
		return 1;
	}
}

#-------------------------------------------------------------------------#
# 쥹
# : դä륹å
# : ꤷɤ
sub merge {
	my($this, $thread) = @_;
	my $i;
	my $flag = 0;
	for ($i=0; $i<=$main::conf{limit}; $i++) {
		my $str = $thread->getArticle($i);
		if (defined $str) {
			$frag |= $this->setArticle($i, $thread->getArticle($i));
		}
	}
	return $frag;
}

#-------------------------------------------------------------------------#
# 쥹
sub plastic {
	my($this) = @_;
	my $article;
	local $_;
	for ($i=0; $i<=$main::conf{limit}; $i++) {
		$_ = $$this{article}[$i];
		next unless (defined);
		$_ = "<a name=$i>" . $_;
		s/<a href=[^>]*>(>>|&gt;&gt;||&gt;)(\d+)(.*?)<\/a>/$1$2$3/g;
		s/(>>|&gt;&gt;||&gt;)(\d+)/<a href=#$2>$1$2<\/a>/g;
		$$this{article}[$i] = $_;
	}
}

#-------------------------------------------------------------------------#
# 
# : ɤ
sub print {
	my($this) = @_;
	my $i;
	my $f = 1;
	$f &= print "<html><head><title>$$this{title}</title></head><body>\n";
	$f &= print "<font size=+1 color=red>$$this{title}</font><dl>\n";

	for ($i=0; $i<=$main::conf{limit}; $i++) {
		if (defined $$this{article}[$i]) {
			$f &= print "<dt>$$this{article}[$i]\n";
		}
	}

	$f &= print "</dl><hr></body></html>\n";
	return $f;
}

1;
